org.cpsolver.studentsct.heuristics.selection

## Class ShuffleStudentsSelection

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.selection.ShuffleStudentsSelection

- All Implemented Interfaces:
    NeighbourSelection<Request,Enrollment>

      public class ShuffleStudentsSelection
      extends Object
      implements NeighbourSelection<Request,Enrollment>

  Shuffle students along request groups. This selection tries to improve the ability to keep students of the same request group together by moving students of a request group that are spread over multiple sections into a single section or into a fewer number of sections.
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ShuffleStudentsSelection.ShuffleBacktrackNeighbourSelection` A special version of the `BacktrackNeighbourSelection` that filters the enrollments with the provided section filter.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ShuffleStudentsSelection(DataProperties properties)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Solver<Request,Enrollment> solver)` Criterion initialization
    `Neighbour<Request,Enrollment>` | `selectNeighbour(Solution<Request,Enrollment> solution)` select a neighbour of a given solution

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ShuffleStudentsSelection

          public ShuffleStudentsSelection(DataProperties properties)

      Constructor
      Parameters:
        `properties` - the selection has no properties at the moment

  - ### Method Detail

    - #### init

          public void init(Solver<Request,Enrollment> solver)

      Description copied from interface: `NeighbourSelection`
      Criterion initialization
      Specified by:
        `init` in interface `NeighbourSelection<Request,Enrollment>`
      Parameters:
        `solver` - current solver

    - #### selectNeighbour

          public Neighbour<Request,Enrollment> selectNeighbour(Solution<Request,Enrollment> solution)

      Description copied from interface: `NeighbourSelection`
      select a neighbour of a given solution
      Specified by:
        `selectNeighbour` in interface `NeighbourSelection<Request,Enrollment>`
      Parameters:
        `solution` - given solution
      Returns:
        a neighbour assignment